{First we need some free memory for the song to be loaded : }
{$M 16384,0,32767}

{**********************************************************}
{** PRG     : Sonic Demo                                 **}
{** LANGUAGE: Turbo Pascal 7.0                           **}
{** AUTHOR  : Marco Grubert; 100120,501                  **}
{** VERSION : 1.0                                        **}
{**********************************************************}
{** DESCRIPTION :                                        **}
{** This program demonstrates how easy it is to play     **}
{** sound files and samples with the help of Tobias      **}
{** Downer's Sonic driver and my interface unit.         **}
{**********************************************************}
{** I am not responsible for any damages which may result**}
{** from the use of the unit or this demo program !      **}
{**********************************************************}

PROGRAM SonicDemo;

USES    Sonic ,     { include the Sonic Sound Unit }
        CRT   ;

VAR     ch       : Char     ;   { For reading keys from the keyboard }
        SongName : STRING   ;
        SampleName:STRING   ;
        SongLoaded,             { Check whether Song or Sample has already }
        SampleLoaded: BOOLEAN;  { been loaded }

{ Simple Error Handler : Removes loaded song and/or sample }
{ Note : The Driver is automatically removed by the Sonic unit    }
PROCEDURE Error;
BEGIN
  WriteLn('Error Number : ',DriverError);
  WriteLn('               ',ErrorMessage);
  IF SampleLoaded THEN RemoveSample(60);
  IF SongLoaded   THEN RemoveSong;
  Halt(1);
END;

PROCEDURE CopyRight;
BEGIN
  WriteLn('*********************** Sonic Driver and Turbo Pascal Unit Demo ****************');
  WriteLn;
  WriteLn('This program is going to demonstrate how easy it is to write Turbo Pascal');
  WriteLn('programs which make full use of Soundblaster compatible cards.');
  WriteLn;
  WriteLn(' Sonic Driver      (c) by Tobias Downer - U.S.A.');
  WriteLn(' Sonic Unit & Demo (c) by Marco Grubert - Germany');
  WriteLn;
  WriteLn(' Please press ENTER ! ');
  WriteLn('********************************************************************************');
  ReadLn;
END;

BEGIN
  CopyRight;

  {Reset Variables}
  ch:=#0; Songloaded:=FALSE; SampleLoaded:=FALSE;

  ClrScr;

  { First load driver, then ask for the name of the song }
  IF NOT LoadDriver('') THEN Error;
  Write  ('Please enter song name (e.g.: Example.SB): ');
  ReadLn (SongName);

  { Try to load song and toggle variable if succesful }
  IF NOT LoadSong(SongName) THEN Error;
  SongLoaded:=TRUE;

  { Read the sample name }
  Write  ('Now, please enter a sample name (Cymbal.SND): ');
  ReadLn (SampleName);
  { Try to load sample and put it in slot 60 }
  { 60 was chosen because one can be sure that the sound module won't
    occupy so high a slot number                                      }
  IF NOT LoadSample(Samplename,60) THEN Error;
  SampleLoaded:=TRUE;

  WriteLn; WriteLn;
  WriteLn('Now let''s play the song ...');
  Delay(1000);

  { Start playing the song and repeat it and repeat it and repeat it and re..}
  IF NOT PlaySong(True) THEN Error;
  WriteLn;
  WriteLn('You can play the sample by typing S');
  { Reset Random Number Generator }
  Randomize;

  REPEAT
    IF KeyPressed THEN BEGIN
      ch:=ReadKey;
      IF UpCase(ch)='S' THEN   { Press S for Sample }
        PlaySample( 60,        { Sample is in Slot 60 }
                    63, 63,    { Maximum Volume for both channels }
                    8,         { Channel # 8 won't be used by the song }
                    15000  );  { Play sample at Frequency of 15000 }
    END;
    { Now let's add some color and graphics ;-> }
    TextColor(Random(15));
    GotoXy(Random(80),Random(15)+6); Write(#14);
  UNTIL ch=#27;           { Press ESC to quit }

  RemoveSample(60);       { Now the sample will be removed from slot 60 }
  StopSong;               { The music stops and }
  RemoveSong;             { the memory is being freed up }
  TextColor(LightGray);
  ClrScr;
END.